'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.prompt = exports.confirm = exports.alert = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

//
// Promisifies GenericDialog
//
var dialog = function () {
	var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(title, message, actions) {
		var div, deferred, cleanUp, props, result;
		return regeneratorRuntime.wrap(function _callee2$(_context2) {
			while (1) {
				switch (_context2.prev = _context2.next) {
					case 0:
						cleanUp = function cleanUp() {
							_reactDom2.default.unmountComponentAtNode(div);
							div.remove();
						};

						div = document.createElement('div');

						document.body.appendChild(div);
						deferred = (0, _promiseDefer2.default)();
						props = { title: title, message: message, actions: actions, deferred: deferred, cleanUp: cleanUp };

						_reactDom2.default.render(_react2.default.createElement(GenericDialog, props), div);
						_context2.next = 8;
						return deferred.promise;

					case 8:
						result = _context2.sent;
						return _context2.abrupt('return', result);

					case 10:
					case 'end':
						return _context2.stop();
				}
			}
		}, _callee2, this);
	}));

	return function dialog(_x2, _x3, _x4) {
		return _ref2.apply(this, arguments);
	};
}();

//
// alert
//


var alert = exports.alert = function () {
	var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3(title, message) {
		return regeneratorRuntime.wrap(function _callee3$(_context3) {
			while (1) {
				switch (_context3.prev = _context3.next) {
					case 0:
						if (typeof message == 'undefined') {
							message = title;
							title = 'Alert';
						}

						_context3.next = 3;
						return dialog(title, _react2.default.createElement(
							'div',
							null,
							message
						), [{
							label: 'Okay',
							onClick: function onClick(close) {
								return close();
							}
						}]);

					case 3:
					case 'end':
						return _context3.stop();
				}
			}
		}, _callee3, this);
	}));

	return function alert(_x5, _x6) {
		return _ref3.apply(this, arguments);
	};
}();

//
// confirm
//


var confirm = exports.confirm = function () {
	var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4(title, message) {
		return regeneratorRuntime.wrap(function _callee4$(_context4) {
			while (1) {
				switch (_context4.prev = _context4.next) {
					case 0:
						if (typeof message == 'undefined') {
							message = title;
							title = 'Confirm';
						}

						_context4.next = 3;
						return dialog(title, _react2.default.createElement(
							'div',
							null,
							message
						), [{
							label: 'No',
							onClick: function onClick(close) {
								return close(false);
							}
						}, {
							label: 'Yes',
							onClick: function onClick(close) {
								return close(true);
							}
						}]);

					case 3:
						return _context4.abrupt('return', _context4.sent);

					case 4:
					case 'end':
						return _context4.stop();
				}
			}
		}, _callee4, this);
	}));

	return function confirm(_x7, _x8) {
		return _ref4.apply(this, arguments);
	};
}();

//
// prompt
//


var prompt = exports.prompt = function () {
	var _ref5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee5(title, message, defaultValue) {
		return regeneratorRuntime.wrap(function _callee5$(_context5) {
			while (1) {
				switch (_context5.prev = _context5.next) {
					case 0:
						if (typeof message == 'undefined') {
							message = title;
							title = 'Prompt';
						}

						_context5.next = 3;
						return dialog(title, _react2.default.createElement(PromptPane, { message: message, defaultValue: defaultValue }), [{
							label: 'Cancel',
							onClick: function onClick(close) {
								return close();
							}
						}, {
							label: 'Okay',
							onClick: function onClick(close, component) {
								return close(component.state.text);
							}
						}]);

					case 3:
						return _context5.abrupt('return', _context5.sent);

					case 4:
					case 'end':
						return _context5.stop();
				}
			}
		}, _callee5, this);
	}));

	return function prompt(_x9, _x10, _x11) {
		return _ref5.apply(this, arguments);
	};
}();

var _promiseDefer = require('promise-defer');

var _promiseDefer2 = _interopRequireDefault(_promiseDefer);

var _dialog = require('react-toolbox/lib/dialog');

var _dialog2 = _interopRequireDefault(_dialog);

var _input = require('react-toolbox/lib/input');

var _input2 = _interopRequireDefault(_input);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//
// Props:
// 	- title
// 	- message (a component)
// 	- actions: [ { label: ..., onClick: (close, component) => ... }, ... ]
// 	- deferred
// 	- cleanUp: call when the dom can be cleaned up
//
var GenericDialog = function (_React$Component) {
	_inherits(GenericDialog, _React$Component);

	function GenericDialog(props) {
		_classCallCheck(this, GenericDialog);

		var _this = _possibleConstructorReturn(this, (GenericDialog.__proto__ || Object.getPrototypeOf(GenericDialog)).call(this, props));

		_this.state = { active: false };
		return _this;
	}

	_createClass(GenericDialog, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			var _this2 = this;

			setImmediate(function () {
				return _this2.setState({ active: true });
			});
		}
	}, {
		key: 'onActionClick',
		value: function onActionClick(originalClick) {
			originalClick(this.close.bind(this), this.refs.$c);
		}
	}, {
		key: 'close',
		value: function () {
			var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(result) {
				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								this.setState({ active: false });
								this.props.deferred.resolve(result);
								_context.next = 4;
								return new Promise(function (y) {
									return setTimeout(y, 1000);
								});

							case 4:
								this.props.cleanUp();

							case 5:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			function close(_x) {
				return _ref.apply(this, arguments);
			}

			return close;
		}()
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var component = _react2.default.cloneElement(this.props.message, { ref: '$c' });
			return _react2.default.createElement(
				_dialog2.default,
				{ active: this.state.active,
					title: this.props.title,
					actions: this.props.actions.map(function (action) {
						var click = action.onClick;
						return {
							label: action.label,
							onClick: _this3.onActionClick.bind(_this3, click)
						};
					}),
					onEscKeyDown: this.close.bind(this),
					onOverlayClick: this.close.bind(this) },
				component
			);
		}
	}]);

	return GenericDialog;
}(_react2.default.Component);

var PromptPane = function (_React$Component2) {
	_inherits(PromptPane, _React$Component2);

	function PromptPane(props) {
		_classCallCheck(this, PromptPane);

		var _this4 = _possibleConstructorReturn(this, (PromptPane.__proto__ || Object.getPrototypeOf(PromptPane)).call(this, props));

		_this4.state = { text: props.defaultValue };
		return _this4;
	}

	_createClass(PromptPane, [{
		key: 'render',
		value: function render() {
			var _this5 = this;

			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					'div',
					null,
					this.props.message
				),
				_react2.default.createElement(
					'div',
					null,
					_react2.default.createElement(_input2.default, { value: this.state.text, onChange: function onChange(text) {
							return _this5.setState({ text: text });
						} })
				)
			);
		}
	}]);

	return PromptPane;
}(_react2.default.Component);